# Class VulkanSubmitInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanSubmitInfo

All Implemented Interfaces:
  `VulkanSubmitInfoType`

public final class VulkanSubmitInfo extends Object implements VulkanSubmitInfoType
The type of Vulkan submission information.

See Also:
  - "VkSubmitInfo2"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanSubmitInfo.Builder`
  Builds instances of type `VulkanSubmitInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanSubmitInfo.Builder`
  `builder()`
  Creates a builder for `VulkanSubmitInfo`.
  `List<VulkanCommandBufferSubmitInfo>`
  `commandBuffers()`
  `static VulkanSubmitInfo`
  `copyOf(VulkanSubmitInfoType instance)`
  Creates an immutable copy of a `VulkanSubmitInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanSubmitInfo` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `waitSemaphores`, `commandBuffers`, `signalSemaphores`.
  `List<VulkanSemaphoreSubmitInfo>`
  `signalSemaphores()`
  `String`
  `toString()`
  Prints the immutable value `VulkanSubmitInfo` with attribute values.
  `List<VulkanSemaphoreSubmitInfo>`
  `waitSemaphores()`
  `final VulkanSubmitInfo`
  `withCommandBuffers(VulkanCommandBufferSubmitInfo... elements)`
  Copy the current immutable object with elements that replace the content of `commandBuffers`.
  `final VulkanSubmitInfo`
  `withCommandBuffers(Iterable<? extends VulkanCommandBufferSubmitInfo> elements)`
  Copy the current immutable object with elements that replace the content of `commandBuffers`.
  `final VulkanSubmitInfo`
  `withSignalSemaphores(VulkanSemaphoreSubmitInfo... elements)`
  Copy the current immutable object with elements that replace the content of `signalSemaphores`.
  `final VulkanSubmitInfo`
  `withSignalSemaphores(Iterable<? extends VulkanSemaphoreSubmitInfo> elements)`
  Copy the current immutable object with elements that replace the content of `signalSemaphores`.
  `final VulkanSubmitInfo`
  `withWaitSemaphores(VulkanSemaphoreSubmitInfo... elements)`
  Copy the current immutable object with elements that replace the content of `waitSemaphores`.
  `final VulkanSubmitInfo`
  `withWaitSemaphores(Iterable<? extends VulkanSemaphoreSubmitInfo> elements)`
  Copy the current immutable object with elements that replace the content of `waitSemaphores`.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### waitSemaphores

    public List<VulkanSemaphoreSubmitInfo> waitSemaphores()
    Specified by:
      `waitSemaphores` in interface `VulkanSubmitInfoType`
    Returns:
      A list of semaphores upon which to wait before the command buffers for this batch begin execution. If semaphores to wait on are provided, they define a semaphore wait operation.

  - ### commandBuffers

    public List<VulkanCommandBufferSubmitInfo> commandBuffers()
    Specified by:
      `commandBuffers` in interface `VulkanSubmitInfoType`
    Returns:
      A list of command buffers to execute in the batch.

  - ### signalSemaphores

    public List<VulkanSemaphoreSubmitInfo> signalSemaphores()
    Specified by:
      `signalSemaphores` in interface `VulkanSubmitInfoType`
    Returns:
      A list of semaphores which will be signaled when the command buffers for this batch have completed execution. If semaphores to be signaled are provided, they define a semaphore signal operation.

  - ### withWaitSemaphores

    public final VulkanSubmitInfo withWaitSemaphores(VulkanSemaphoreSubmitInfo... elements)
    Copy the current immutable object with elements that replace the content of `waitSemaphores`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withWaitSemaphores

    public final VulkanSubmitInfo withWaitSemaphores(Iterable<? extends VulkanSemaphoreSubmitInfo> elements)
    Copy the current immutable object with elements that replace the content of `waitSemaphores`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of waitSemaphores elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withCommandBuffers

    public final VulkanSubmitInfo withCommandBuffers(VulkanCommandBufferSubmitInfo... elements)
    Copy the current immutable object with elements that replace the content of `commandBuffers`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withCommandBuffers

    public final VulkanSubmitInfo withCommandBuffers(Iterable<? extends VulkanCommandBufferSubmitInfo> elements)
    Copy the current immutable object with elements that replace the content of `commandBuffers`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of commandBuffers elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withSignalSemaphores

    public final VulkanSubmitInfo withSignalSemaphores(VulkanSemaphoreSubmitInfo... elements)
    Copy the current immutable object with elements that replace the content of `signalSemaphores`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withSignalSemaphores

    public final VulkanSubmitInfo withSignalSemaphores(Iterable<? extends VulkanSemaphoreSubmitInfo> elements)
    Copy the current immutable object with elements that replace the content of `signalSemaphores`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of signalSemaphores elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanSubmitInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `waitSemaphores`, `commandBuffers`, `signalSemaphores`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanSubmitInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanSubmitInfo copyOf(VulkanSubmitInfoType instance)
    Creates an immutable copy of a `VulkanSubmitInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanSubmitInfo instance

  - ### builder

    public static VulkanSubmitInfo.Builder builder()
    Creates a builder for `VulkanSubmitInfo`.

        VulkanSubmitInfo.builder()
           .addWaitSemaphores|addAllWaitSemaphores(VulkanSemaphoreSubmitInfo) // waitSemaphores elements
           .addCommandBuffers|addAllCommandBuffers(VulkanCommandBufferSubmitInfo) // commandBuffers elements
           .addSignalSemaphores|addAllSignalSemaphores(VulkanSemaphoreSubmitInfo) // signalSemaphores elements
           .build();

    Returns:
      A new VulkanSubmitInfo builder